<script lang="ts" setup>
import { useLoadingStore } from '@/stores/loading'
import { useMemberStore } from '@/stores/member'
import memberService from '@/services/member'

import { nextTick, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const memberStore = useMemberStore()
const loadingStore = useLoadingStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
function onSubmit() {}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    memberStore.clear()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await memberStore.saveMember()
  closeDialog()
}
</script>
<template>
  <v-btn prepend-icon="mdi-account-multiple-plus" elevation="10" block
    >Add New Member
    <!-- add new member dialog -->

    <v-dialog v-model="memberStore.addNewMemberDialog" persistent activator="parent" width="auto">
      <v-card color="white" min-width="400pt">
        <v-container>
          <v-row>
            <v-card-title style="color: rgb(247, 156, 82)">
              <v-icon icon="mdi-account-multiple-plus"></v-icon>
              Add New Member
            </v-card-title>
          </v-row>
        </v-container>
        <v-card-text>
          <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="auto" md="12">
                  Member's Name
                  <v-text-field
                    clearable
                    label="Name"
                    variant="outlined"
                    v-model="memberStore.editedMember.name"
                  ></v-text-field>
                </v-col>
                <v-col cols="auto" md="12">
                  Member's Phone
                  <v-text-field
                    clearable
                    label="Telephone Number"
                    variant="outlined"
                    v-model="memberStore.editedMember.tel"
                  ></v-text-field>
                </v-col>

                <v-col cols="auto" md="12">
                  Member's Point
                  <v-text-field
                    clearable
                    label="Point"
                    variant="outlined"
                    v-model="memberStore.editedMember.point"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-container>
            <v-row>
              <v-col
                ><v-btn color="black" @click="memberStore.cancel()" elevation="4" block rounded="lg"
                  >Cancel
                </v-btn></v-col
              >
              <v-col
                ><v-btn
                  style="background-color: rgb(247, 156, 82)"
                  color="black"
                  @click="save()"
                  elevation="4"
                  block
                  rounded="lg"
                  >Save
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-btn>
</template>
